package tech.xiongweixp.pptassistant

import kotlinx.coroutines.GlobalScope
import kotlinx.coroutines.launch
import java.io.OutputStream
import java.net.Socket

class ControlUtil private constructor(){
    private var socket: Socket?=null
    private var os :  OutputStream?=null
    companion object{
        private var _INSTANCE:ControlUtil?=null
        fun getInstance() = if(_INSTANCE==null) {
                _INSTANCE = ControlUtil()
                _INSTANCE
            }else{
                _INSTANCE
            }
        const val PORT = 1234
    }

    fun connect(ip:String){
        GlobalScope.launch {
            socket = Socket(ip,PORT)
            os = socket?.getOutputStream()
        }
    }

    fun close(){
        GlobalScope.launch {
            os?.close()
            socket?.close()
        }
    }

    fun start(){
        GlobalScope.launch {
            os?.write("F5\r\n".toByteArray())
            os?.flush()
        }

    }

    fun stop(){
        GlobalScope.launch {
            os?.write("Escape\r\n".toByteArray())
            os?.flush()
        }

    }

    fun next(){
        GlobalScope.launch {
            os?.write("Right\r\n".toByteArray())
            os?.flush()
        }
    }

    fun previous(){
        GlobalScope.launch {
            os?.write("Left\r\n".toByteArray())
            os?.flush()
        }
    }

}